package cz.jzitnik.game.entities;

import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class Player {
    private int health = 10;
    private int hunger = 10;
    private int fallDistance = 0;
    private Block playerBlock1;
    private Block playerBlock2;

    public synchronized void heal() {
        if (hunger > 3 && health < 10) {
            health = Math.min(health + 1, 10);
        }
    }

    public synchronized void drainHunger() {
        if (hunger > 0) {
            hunger--;
        }
    }

    public void addFalling() {
        fallDistance++;
    }

    public void fell() {
        int damage = Math.max(fallDistance - 3, 0);
        health = Math.max(0, health - damage);
        fallDistance = 0;
    }
}
