package cz.jzitnik.game.handlers.place.handlers;

import cz.jzitnik.game.Game;
import cz.jzitnik.game.annotations.PlaceHandler;
import cz.jzitnik.game.entities.Block;
import cz.jzitnik.game.entities.items.Item;
import cz.jzitnik.game.handlers.place.CustomPlaceHandler;

@PlaceHandler("bucket")
public class BucketPlaceHandler implements CustomPlaceHandler {
    @Override
    public boolean place(Game game, int x, int y) {
        return false;
    }

    @Override
    public void mine(Game game, int x, int y) {
        var world = game.getWorld();
        var blocks = world[y][x];
        var flowingBlocks = blocks.stream().filter(Block::isFlowing).toList();

        if (flowingBlocks.isEmpty()) {
            return;
        }

        var flowingBlock = flowingBlocks.getFirst();
        var items = flowingBlock.getDrops();
        for (Item item : items) {
            game.getInventory().addItem(item);
        }
        blocks.remove(flowingBlock);
    }
}
