package cz.jzitnik.game.sprites;

import cz.jzitnik.tui.ResourceLoader;
import cz.jzitnik.tui.Sprite;

import java.util.Optional;

public class Heart extends Sprite {
    public enum HeartState {
        OFF, ON,
    }

    public String getSprite() {
        return getSprite(HeartState.OFF);
    }

    public String getSprite(Enum e) {
        return ResourceLoader.loadResource(switch (e) {
            case HeartState.OFF -> "gui/heartempty.ans";
            case HeartState.ON -> "gui/heartfull.ans";
            default -> throw new IllegalStateException("Unexpected value: " + e);
        });
    }

    @Override
    public Optional<Class<HeartState>> getStates() {
        return Optional.of(HeartState.class);
    }
}
