package cz.jzitnik.game.sprites;

import cz.jzitnik.tui.ResourceLoader;
import cz.jzitnik.tui.Sprite;

import java.util.Optional;

public class Lava extends Sprite {
    public enum LavaState {
        FIRST, SECOND, THIRD, FOURTH, FIFTH;

        public static LavaState get(int x) {
            return switch (x) {
                case 5 -> FIRST;
                case 4 -> SECOND;
                case 3 -> THIRD;
                case 2 -> FOURTH;
                case 1 -> FIFTH;
                default -> throw new IllegalStateException("Unexpected value: " + x);
            };
        }
    }

    public String getSprite() {
        return getSprite(LavaState.FIRST);
    }

    public String getSprite(Enum e) {
        String[] resource = ResourceLoader.loadResource("lava.ans").split("\n");

        int numberFormTop = switch (e) {
            case LavaState.FIRST -> 0;
            case LavaState.SECOND -> 5;
            case LavaState.THIRD -> 10;
            case LavaState.FOURTH -> 15;
            case LavaState.FIFTH -> 20;
            default -> throw new IllegalStateException("Unexpected value: " + e);
        };

        StringBuilder stringBuilder = new StringBuilder();

        for (int i = 0; i < 25; i++) {
            if (i < numberFormTop) {
                stringBuilder.append("\033[49m ".repeat(50));
            } else {
                stringBuilder.append(resource[i]);
            }
            stringBuilder.append("\n");
        }

        return stringBuilder.toString();
    }

    @Override
    public Optional<Class<LavaState>> getStates() {
        return Optional.of(LavaState.class);
    }
}
