package cz.jzitnik.game.ui;

import cz.jzitnik.game.Game;

import java.util.HashMap;

public class CloseHandler {
    @FunctionalInterface
    public interface Function<T> {
        void call(T t);
    }

    public static HashMap<Window, Function<Game>> handles = new HashMap<>();

    static {
        handles.put(Window.CRAFTING_TABLE, game -> game.getGameStates().craftingTable.exit());
        handles.put(Window.INVENTORY, game -> game.getInventory().exit());
    }

    public static void handle(Window window, Game game) {
        if (handles.containsKey(window)) {
            var func = handles.get(window);

            func.call(game);
        }
    }
}
